package gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.File;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.ScrollPaneConstants;
import javax.swing.filechooser.FileNameExtensionFilter;

import tasks.ChiTest;
import tasks.EmbedInc;
import tasks.EmbedKey;
import tasks.EmbedLSB;
import tasks.EmbedParity;
import tasks.EmbeddingAlgorithm;
import tasks.HelperFunctions;


/**
 *
 * @author  Arne
 */
public class GuiMainWindow extends javax.swing.JFrame {
    
	static final long serialVersionUID = 1;
	
//	 Variables declaration - do not modify
	//Stego Elements
	private EmbedLSB embLsb;
	private tasks.EmbedKey embKey;
	private EmbedParity embPar;
	private EmbeddingAlgorithm embInc;
	
	//GUI Elements
	private JButton btn_visualattack;
    private JButton btn_embed;
    private JButton btn_extract;
    private javax.swing.JComboBox<String> jComboBox1;
    private JLabel jLabel1;
    private JLabel jLabel10;
    private JLabel jLabel2;
    private JLabel jLabel3;
    private JLabel lbl_embeddingRate;
    private JLabel lbl_shrinkageRate;
    private JLabel lbl_alterationRate;
    private JLabel lbl_capacity;
    private JLabel jLabel7;
    private JLabel jLabel8;
    private JLabel jLabel9;
    private JPanel jPanel1;
    private JPanel sourcePanel;
    private JPanel panelStegoImage;
    private GuiPgmLabel sourceImage;
    private GuiPgmLabel stegoImage = null;
    private JPanel jPanel3;
    private JPanel jPanel4;
    private javax.swing.JRadioButton radiobtn_100;
    private javax.swing.JRadioButton radiobtn_75;
    private javax.swing.JRadioButton radiobtn_25;
    private javax.swing.JTextArea jTextPane1;
    private javax.swing.JTextPane txt_blocksize;
    private JScrollPane scr_pane;
    private JLabel lbl_blocksize;
    private JLabel lbl_Kap;
    private JButton btn_X2;
    // End of variables declaration
    
    
    /** Creates new form GuiMainWindow */
    public GuiMainWindow() {
//    	initStego
    	embLsb = new EmbedLSB();
    	embKey = new EmbedKey();
    	embPar = new EmbedParity();
    	embInc = new EmbedInc();
        initComponents();
        this.setSize(1050,800);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     */
    private void initComponents() {
    	
    	//initGUI
    	btn_visualattack = new JButton();
        jTextPane1 = new javax.swing.JTextArea();
        jPanel3 = new javax.swing.JPanel();
        jPanel1 = new javax.swing.JPanel();
        jLabel7 = new javax.swing.JLabel();
        panelStegoImage = new javax.swing.JPanel();
        jLabel8 = new javax.swing.JLabel();
        jPanel4 = new javax.swing.JPanel();
        jComboBox1 = new javax.swing.JComboBox<String>();
        radiobtn_100 = new javax.swing.JRadioButton();
        radiobtn_75 = new javax.swing.JRadioButton();
        radiobtn_25 = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        lbl_embeddingRate = new javax.swing.JLabel();
        lbl_shrinkageRate = new javax.swing.JLabel();
        lbl_alterationRate = new javax.swing.JLabel();
        lbl_capacity = new JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel9 = new javax.swing.JLabel();
        jLabel10 = new javax.swing.JLabel();
        btn_embed = new javax.swing.JButton();
        btn_extract = new javax.swing.JButton();
        scr_pane = new JScrollPane();
        txt_blocksize = new JTextPane();
        lbl_blocksize = new JLabel(tasks.Main.messages.getString("guiMainWindow_blocksize"));
        lbl_Kap = new JLabel();
        btn_X2 = new JButton();
        
        this.setTitle(tasks.Main.messages.getString("guiMainWindow_title"));
        
        getContentPane().setLayout(null);

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setResizable(false);
        
        JPanel extractedTextPanel = new JPanel();
        extractedTextPanel.setBounds(340, 40, 650, 370);

        extractedTextPanel.setLayout(new BorderLayout());
        JLabel extractedTextLabel = new JLabel(
        		tasks.Main.messages.getString("guiMainWindow_extractedText"));
        extractedTextPanel.add(extractedTextLabel, BorderLayout.NORTH);
        
        jTextPane1.setSize(650,1000);
        jTextPane1.setMaximumSize(new Dimension(650,3000));
        jTextPane1.setFont(new Font(java.awt.Font.MONOSPACED,Font.PLAIN, 12));
        jTextPane1.setEditable(false);
        jTextPane1.setLineWrap(true);
        scr_pane.add(jTextPane1);
        scr_pane.setViewportView(jTextPane1);
        scr_pane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        scr_pane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
        extractedTextPanel.add(scr_pane, BorderLayout.CENTER);
        getContentPane().add(extractedTextPanel);

        jPanel3.setLayout(new BorderLayout());

        // more flexible picture selection (file selector)
        
        JFileChooser chooser = new JFileChooser();
        FileNameExtensionFilter filter = new FileNameExtensionFilter(
            "PGM Images", "pgm", "PGM");
        chooser.setFileFilter(filter);
        chooser.setControlButtonsAreShown(false);
        chooser.setFileSelectionMode(JFileChooser.FILES_ONLY);
        chooser.setMultiSelectionEnabled(false);
        chooser.setAcceptAllFileFilterUsed(false);
        chooser.setCurrentDirectory(new File(System.getProperty("user.dir")));
        chooser.setBounds(5, 5, 310, 350);
        chooser.addPropertyChangeListener(new PropertyChangeListener() {
            public void propertyChange(PropertyChangeEvent e) {
            	chooserPropertyChanged(e);
            }
        });
        
        jPanel3.add(chooser, BorderLayout.WEST);
        
        JPanel picPanel = new JPanel(new GridLayout(1,2));
        jPanel3.add(picPanel, BorderLayout.CENTER);
        
        jPanel1.setLayout(new BorderLayout());
        jPanel1.setMinimumSize(new java.awt.Dimension(255, 310));
        jPanel1.setPreferredSize(new java.awt.Dimension(255, 310));
        picPanel.add(jPanel1);
        
        sourcePanel = new JPanel(new BorderLayout());
        jPanel1.add(sourcePanel, BorderLayout.CENTER);
        
        //male das vieh
        sourceImage = new GuiPgmLabel(new File("eagle.pgm"));
        sourcePanel.add(sourceImage, BorderLayout.CENTER);
       
        jLabel7.setText(tasks.Main.messages.getString("guiMainWindow_coverImage"));
        jLabel7.setHorizontalAlignment(JLabel.CENTER);
        jPanel1.add(jLabel7, BorderLayout.NORTH);
       
        JPanel stegoPanel = new JPanel(new BorderLayout());
        stegoPanel.setMinimumSize(new java.awt.Dimension(255, 310));
        stegoPanel.setPreferredSize(new java.awt.Dimension(255, 310));
        picPanel.add(stegoPanel);

        jLabel8.setText(tasks.Main.messages.getString("guiMainWindow_stegoImage"));
        jLabel8.setHorizontalAlignment(JLabel.CENTER);
        stegoPanel.add(jLabel8, BorderLayout.NORTH);
        
        panelStegoImage = new JPanel(new BorderLayout());
        stegoPanel.add(panelStegoImage, BorderLayout.CENTER);
        

        getContentPane().add(jPanel3);
        jPanel3.setBounds(0, 470, 1020, 290);

        jPanel4.setLayout(null);

        jLabel10.setText(tasks.Main.messages.getString("guiMainWindow_embeddingAlgorithm"));
        jPanel4.add(jLabel10);
        jLabel10.setBounds(10, 20, 200, 23);
        
        jPanel4.add(jComboBox1);
        jComboBox1.setBounds(10, 43, 250, 22);
        jComboBox1.addItem(new String(tasks.Main.messages.getString("guiMainWindow_LSBOverwrite")));
        jComboBox1.addItem(new String(tasks.Main.messages.getString("guiMainWindow_LSBParity")));
        jComboBox1.addItem(new String(tasks.Main.messages.getString("guiMainWindow_LSBIncrementation")));
        jComboBox1.addItem(new String(tasks.Main.messages.getString("guiMainWindow_LSBwithKey")));
        jComboBox1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	jComboBox1ActionPerformed(evt);
            }
        });
        
        jLabel9.setText(tasks.Main.messages.getString("guiMainWindow_MessageCapacity"));
        jPanel4.add(jLabel9);
        jLabel9.setBounds(10, 80, 200, 23);
        
        ButtonGroup bgNachricht = new ButtonGroup();

        radiobtn_100.setSelected(true);
        radiobtn_100.setText(tasks.Main.messages.getString("guiMainWindow_Text100"));
        bgNachricht.add(radiobtn_100);
        radiobtn_100.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radiobtn_100ActionPerformed(evt);
            }
        });
        jPanel4.add(radiobtn_100);
        radiobtn_100.setBounds(10, 100, 180, 23);

        radiobtn_75.setText(tasks.Main.messages.getString("guiMainWindow_Random75"));
        bgNachricht.add(radiobtn_75);
        jPanel4.add(radiobtn_75);
        radiobtn_75.setBounds(10, 123, 180, 23);
        radiobtn_75.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radiobtn_75ActionPerformed(evt);
            }
        });
        
        radiobtn_25.setText(tasks.Main.messages.getString("guiMainWindow_Random25"));
        bgNachricht.add(radiobtn_25);
        jPanel4.add(radiobtn_25);
        radiobtn_25.setBounds(10, 146, 180, 23);
        radiobtn_25.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                radiobtn_25ActionPerformed(evt);
            }
        });
        
        lbl_Kap.setText(tasks.Main.messages.getString("guiMainWindow_capacity"));
        jPanel4.add(lbl_Kap);
        lbl_Kap.setBounds(10,180,120,14);
        
        lbl_capacity.setText("-");
        jPanel4.add(lbl_capacity);
        lbl_capacity.setBounds(130,180,100,14);
        
        jLabel1.setText(tasks.Main.messages.getString("guiMainWindow_embeddingRate"));
        jPanel4.add(jLabel1);
        jLabel1.setBounds(10, 200, 120, 14);

        lbl_embeddingRate.setText("-");
        jPanel4.add(lbl_embeddingRate);
        lbl_embeddingRate.setBounds(130, 200, 100, 14);

        jLabel2.setText(tasks.Main.messages.getString("guiMainWindow_shrinkageRate"));
        jPanel4.add(jLabel2);
        jLabel2.setBounds(10, 220, 120, 14);

        lbl_shrinkageRate.setText("-");
        jPanel4.add(lbl_shrinkageRate);
        lbl_shrinkageRate.setBounds(130, 220, 100, 14);

        jLabel3.setText(tasks.Main.messages.getString("guiMainWindow_alterationRate"));
        jPanel4.add(jLabel3);
        jLabel3.setBounds(10, 240, 120, 14);
        
        lbl_alterationRate.setText("-");
        jPanel4.add(lbl_alterationRate);
        lbl_alterationRate.setBounds(130, 240, 100, 14);

        jPanel4.add(this.lbl_blocksize);
        lbl_blocksize.setBounds(10,260,120,14);
        
        txt_blocksize.setText("5");
        jPanel4.add(txt_blocksize);
        txt_blocksize.setBounds(130,255,30,23);

        btn_embed.setText(tasks.Main.messages.getString("guiMainWindow_embed"));
        jPanel4.add(btn_embed);
        btn_embed.setBounds(0, 300, 100, 23);
        btn_embed.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_embedactionPerformed(evt);
            }
        });

        btn_extract.setText(tasks.Main.messages.getString("guiMainWindow_extract"));
        btn_extract.setEnabled(false);
        jPanel4.add(btn_extract);
        btn_extract.setBounds(110, 300, 130, 23);
        btn_extract.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_extractactionPerformed(evt);
            }
        });
        
        btn_visualattack.setText(tasks.Main.messages.getString("guiMainWindow_visualAttack"));
        btn_visualattack.setEnabled(false);
        jPanel4.add(btn_visualattack);
        btn_visualattack.setBounds(0, 350, 150, 23);
        btn_visualattack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
            	btn_visualattackactionPerformed(evt);
            }
        });

        btn_X2.setText(tasks.Main.messages.getString("guiMainWindow_chiTest"));
        btn_X2.setEnabled(false);
        jPanel4.add(btn_X2);
        btn_X2.setBounds(0, 400, 150, 23);
        btn_X2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_X2Performed(evt);
            }
        });
        
        getContentPane().add(jPanel4);
        jPanel4.setBounds(10, 40, 320, 450);
        
        this.lbl_blocksize.setVisible(false);
        this.txt_blocksize.setVisible(false);
        this.jComboBox1.setSelectedIndex(0);
        
        pack();
    }

    private void radiobtn_100ActionPerformed(java.awt.event.ActionEvent evt) {   
    	clearStegoImage();
    }                                             
    private void radiobtn_75ActionPerformed(java.awt.event.ActionEvent evt) {
    	clearStegoImage();
    }      
    private void radiobtn_25ActionPerformed(java.awt.event.ActionEvent evt) {
    	clearStegoImage();
    }      

   private void chooserPropertyChanged(PropertyChangeEvent e) {
       String prop = e.getPropertyName();

       //Update the source image file, if needed
       if (JFileChooser.SELECTED_FILE_CHANGED_PROPERTY.equals(prop)) {
           File newFile = (File) e.getNewValue();
           if (newFile != null && !newFile.equals(sourceImage.getImageFile()))
        	   updateSourceImage(new GuiPgmLabel(newFile));
       }	   
   }
       
    private void btn_embedactionPerformed(java.awt.event.ActionEvent evt)
    {
    	try {
    		String cover = getCurrentCover();
    		HelperFunctions.Image coverImage = HelperFunctions.read(new File(cover + ".pgm"));
    		boolean message[] = getCurrentMessage(coverImage);
    		int percent = getCurrentPercent();
			
			// LSB
			String stegoName = null;
			tasks.HelperFunctions.Image img = null;
    		if(jComboBox1.getSelectedIndex()==0)
    		{
    			img = embLsb.embed(coverImage, percent, message, null);
    			stegoName = cover + "_embLsb" + Integer.toString(percent) + ".pgm";
				this.lbl_capacity.setText(embLsb.getCapacity());
				this.lbl_alterationRate.setText(embLsb.getAlterationRate());
				this.lbl_embeddingRate.setText(embLsb.getEmbeddingRate());
				this.lbl_shrinkageRate.setText(embLsb.getShrinkageRate());
    		}	
    		// Parität
    		else if(jComboBox1.getSelectedIndex()==1)
    		{
    			img = embPar.embed(coverImage, percent, message, new int[]{Integer.parseInt(this.txt_blocksize.getText())});
    			stegoName = cover + "_embPar" + Integer.toString(percent) + ".pgm";
    			this.lbl_capacity.setText(embPar.getCapacity());
    			this.lbl_alterationRate.setText(embPar.getAlterationRate());
    			this.lbl_embeddingRate.setText(embPar.getEmbeddingRate());
    			this.lbl_shrinkageRate.setText(embPar.getShrinkageRate());
    		}
    		// Inkrementieren
    		else if(this.jComboBox1.getSelectedIndex()==2){
    			img = embInc.embed(coverImage, percent, message, null);
    			stegoName = cover + "_embInk" + Integer.toString(percent) + ".pgm";
    			this.lbl_capacity.setText(embInc.getCapacity());
    			this.lbl_alterationRate.setText(embInc.getAlterationRate());
    			this.lbl_embeddingRate.setText(embInc.getEmbeddingRate());
    			this.lbl_shrinkageRate.setText(embInc.getShrinkageRate());
    		}
    		// LSB mit Schlüssel
    		else if(this.jComboBox1.getSelectedIndex()==3){
    			img = embKey.embed(coverImage, percent, message,HelperFunctions.readKey());
    			stegoName = cover + "_embKey" + Integer.toString(percent) + ".pgm";
    			this.lbl_capacity.setText(embKey.getCapacity());
    			this.lbl_alterationRate.setText(embKey.getAlterationRate());
    			this.lbl_embeddingRate.setText(embKey.getEmbeddingRate());
    			this.lbl_shrinkageRate.setText(embKey.getShrinkageRate());
       		}
			HelperFunctions.write(stegoName, img);
	    	stegoImage = new GuiPgmLabel(new File(stegoName));
	        panelStegoImage.removeAll();
			panelStegoImage.add(stegoImage, BorderLayout.CENTER);
			
			btn_extract.setEnabled(true);	
		} 
    	catch (Exception e) {
    		e.printStackTrace();
		}
    }
    
    
    /*
	*****************************************************************************************************
	*Nachricht extrahieren																				*
	*****************************************************************************************************
	*/
    private void btn_extractactionPerformed(java.awt.event.ActionEvent evt){
    	try {
    		char[] text = null;
    		
    		// LSB
    		if(jComboBox1.getSelectedIndex()==0)
    		{
    			text = booleanToChar(embLsb.extract(HelperFunctions.read(
    					stegoImage.getImageFile()), null));
    		}
    		// Parität
    		else if(jComboBox1.getSelectedIndex()==1)
    		{
    			text = booleanToChar(embPar.extract(HelperFunctions.read(
    					stegoImage.getImageFile()),
    					new int[]{Integer.parseInt(this.txt_blocksize.getText())}));
    		}
    		// Inkrementieren
    		else if(jComboBox1.getSelectedIndex()==2)
    		{
    			text = booleanToChar(embInc.extract(HelperFunctions.read(
    					stegoImage.getImageFile()), null));
    		}
    		// LSB mit Key
    		else if(jComboBox1.getSelectedIndex()==3)
    		{
    			text = booleanToChar(embKey.extract(HelperFunctions.read(
    					stegoImage.getImageFile()),
    					HelperFunctions.readKey()));
    		}
			jTextPane1.setText(new String(text));
			jTextPane1.setCaretPosition(0);
	
			btn_extract.setEnabled(false);
			btn_visualattack.setEnabled(true);
			this.btn_X2.setEnabled(true);
    	} catch (Exception e) {
			e.printStackTrace();
		}
    }
    
    
    /*
	*****************************************************************************************************
	*Visueller Angriff														*
	*****************************************************************************************************
	*/
    private void btn_visualattackactionPerformed(java.awt.event.ActionEvent evt){
    	GuiVisualAttack gva = new GuiVisualAttack(sourceImage.getImageFile(), 
    			stegoImage.getImageFile());
    	gva.setVisible(true);
    }
    
    
    /*
	*****************************************************************************************************
	*Anzeige für Blockgröße bei Paritätsgesteuerter Einbettung														
	*****************************************************************************************************
	*/
    private void jComboBox1ActionPerformed(java.awt.event.ActionEvent evt)
    {
    	clearStegoImage();
    	
    	if(jComboBox1.getSelectedIndex()==1){
    		this.lbl_blocksize.setVisible(true);
    		this.txt_blocksize.setVisible(true);
    	}
    	else{
    		this.lbl_blocksize.setVisible(false);
    		this.txt_blocksize.setVisible(false);
    	}
    }
    
    /**
     * Aufruf für Chi-Square-Test
     * @param evt das Event
     */
    private void btn_X2Performed(java.awt.event.ActionEvent evt){
    	String x  = ChiTest.Chitest(stegoImage.getImageFile());
    	this.jTextPane1.setText(x);
    }

    /**
     * Funktion zum Umwandeln von Dualzahlen in ASCII-Zeichen.
     * @param bitfolge die Nachricht in Binärdarstellung.
     * @return Die Nachricht als Zeichenfolge.
     */
   public static char[] booleanToChar(final boolean[] bitfolge) {
        /* Variablendeklaration */
        char[] result = new char[bitfolge.length / 8];

        /* Schleife über alle Nachrichtenbits */
        for (int j = 0; j < (bitfolge.length / 8); j++) {
            result[j] = 0;
            for (int i = 0; i < 8; i++) {
                result[j] |= ((bitfolge[j * 8 + i]?1:0) << i);
            }
        }
        return result;
    }  
   
   /**
    * 
    * @return the name of the cover currently selected (only the main name without
    * filename extension)
    */
   private String getCurrentCover() {
	   int index = sourceImage.getImageFile().getName().lastIndexOf('.');
	   return sourceImage.getImageFile().getName().substring(0, index);
   }
   
   /**
    * 
    * @return the embedding rate percentage currently selected by the radiobuttons 
    */
   private int getCurrentPercent() {
		// Default Prozent der Einbettungskapazität
		int prozent = 100;
		// Nachricht und Prozentauswahl
		if(this.radiobtn_100.isSelected()){
			prozent = 100;
		} else if (this.radiobtn_75.isSelected()) {
			prozent = 75;
		} else if (this.radiobtn_25.isSelected()) {
			prozent = 25;
		}
		return prozent;
   }
   
   /**
    * @param coverImage das Bild, in das die Nachricht eingebettet werden soll. Wird benötigt, um die
    * Mindestlänge für zufällige nachrichten zu ermitteln.
    */
   private boolean[] getCurrentMessage(HelperFunctions.Image coverImage) throws Exception{
		// Default Nachricht 
		boolean nachricht[] = HelperFunctions.readMessage();
		// Nachrichtauswahl
		if(this.radiobtn_100.isSelected()){
			nachricht = HelperFunctions.readMessage();
		} else if (this.radiobtn_75.isSelected()) {
			nachricht = HelperFunctions.getRnd(coverImage.getData().length * 75 / 100);
		} else if (this.radiobtn_25.isSelected()) {
			nachricht = HelperFunctions.getRnd(coverImage.getData().length * 25 / 100);
		}
		return nachricht;
   }
   
   private void updateSourceImage(GuiPgmLabel pgm) {
	   sourceImage = pgm;
   	   sourcePanel.removeAll();
	   sourcePanel.add(sourceImage, BorderLayout.CENTER);
	   sourcePanel.repaint();
	   clearStegoImage();
   }

   private void clearStegoImage() {
	   panelStegoImage.removeAll();
	   panelStegoImage.repaint();
	   this.btn_extract.setEnabled(false);
	   this.btn_visualattack.setEnabled(false);
	   this.btn_X2.setEnabled(false);
	   this.jTextPane1.setText("");
	   this.lbl_alterationRate.setText("-");
	   this.lbl_embeddingRate.setText("-");
	   this.lbl_capacity.setText("-");
	   this.lbl_shrinkageRate.setText("-");
   }
   
}
