package gui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.io.File;

import javax.swing.JLabel;

import tasks.HelperFunctions;


public class GuiPgmLabel extends JLabel {

	static final long serialVersionUID = 1;
	
	private File imageSource;
	private int paintWidth, paintHeight;
	private HelperFunctions.Image cover;
	
	public GuiPgmLabel(File imageSource) throws IllegalArgumentException {
		this.imageSource = imageSource;
		try {
			cover = HelperFunctions.read(imageSource);
		} catch (Exception e) {
			throw new IllegalArgumentException("ImageSource does not contain a valid image.");
		}
		setSize(250,250);
		setMaximumSize(new Dimension(250,250));
        setIgnoreRepaint(false);
        setVisible(true);
		// falls Bild zu groß ist, nur linke obere Ecke zeigen.
        paintWidth = cover.getWidth(); 
        if(paintWidth > 250) {
        	paintWidth = 250;
        }
        paintHeight = cover.getHeight();
		if(paintHeight > 250) {
			paintHeight = 250;
		}
	}

	/**
	 * @return the file the image is taken from.
	 */
	public File getImageFile() {
		return imageSource;
	}
	
	public void paint(Graphics g)
	{
		int count = 0;
		int farbe = 0;
		
		for(int i = (250-paintHeight)/2;i < (paintHeight-1)/2+125;i++)
		{
			for(int j = (250-paintWidth)/2; j < paintWidth/2+125;j++)
			{
				if(count>=cover.getData().length)
				{
					System.out.println("count too high: height = " + i + ", width = "+j );
					break;
				}
				else
				{
					farbe = cover.getData()[count]%256;
					g.setColor(new Color(farbe,farbe,farbe));
					g.drawLine(j,i,j,i);
					count++;
				}
			}
		}
	}

}
