/*
 * GuiVisualAttack.java
 *
 * Created on 22. Januar 2007, 12:29
 */

package gui;

import java.awt.BorderLayout;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.WindowConstants;

import tasks.HelperFunctions;
import tasks.VisualAttack;

/**
 * 
 * @author Arne
 */
public class GuiVisualAttack extends javax.swing.JFrame {

	static final long serialVersionUID = 1;

	private File org, steg;
	private String fileName;
	private String stegFileName;

	/** Creates new form GuiVisualAttack */
	public GuiVisualAttack(File org, File steg) {
		this.org = org;
		this.steg = steg;
		int index = org.getName().lastIndexOf('.');
		fileName = org.getName().substring(0, index);
		index = steg.getName().lastIndexOf('.');
		stegFileName = steg.getName().substring(0, index);
		initComponents();
		this.setSize(1000, 768);
	}

	/**
	 * Initializes the GUI components
	 */
	private void initComponents() {

		panel_emb = new javax.swing.JPanel();
		panel_org = new javax.swing.JPanel();
		panelemblsb = new javax.swing.JPanel();
		panel_orglsb = new javax.swing.JPanel();
		panel_diff = new javax.swing.JPanel();
		jLabel1 = new javax.swing.JLabel();
		lbl_steganogramm = new javax.swing.JLabel();
		lbl_diff = new javax.swing.JLabel();
		lbl_orglsb = new javax.swing.JLabel();
		lbl_steglsb = new javax.swing.JLabel();
		jPanel1 = new javax.swing.JPanel();
		btn_diff = new javax.swing.JButton();
		this.btn_orglsb = new JButton();
		this.btn_steglsb = new JButton();

		this.setTitle(tasks.Main.messages.getString("guiVisualAttack_title"));

		getContentPane().setLayout(null);

		this.setDefaultCloseOperation(WindowConstants.HIDE_ON_CLOSE);

		panel_emb.setMinimumSize(new java.awt.Dimension(250, 250));
		panel_emb.setPreferredSize(new java.awt.Dimension(250, 250));
		getContentPane().add(panel_emb);
		panel_emb.setBounds(660, 80, 250, 250);
		GuiPgmLabel gplsteg = new GuiPgmLabel(steg);
		panel_emb.setLayout(null);
		panel_emb.add(gplsteg);
		panel_emb.repaint();

		panel_org.setMinimumSize(new java.awt.Dimension(250, 250));
		panel_org.setPreferredSize(new java.awt.Dimension(250, 250));
		getContentPane().add(panel_org);
		panel_org.setBounds(80, 80, 250, 250);
		GuiPgmLabel gplorg = new GuiPgmLabel(org);
		panel_org.setLayout(null);
		panel_org.add(gplorg);
		panel_org.repaint();

		panelemblsb.setMinimumSize(new java.awt.Dimension(250, 250));
		panelemblsb.setPreferredSize(new java.awt.Dimension(250, 250));
		getContentPane().add(panelemblsb);
		panelemblsb.setBounds(660, 380, 250, 250);
		panelemblsb.setLayout(new BorderLayout());

		panel_orglsb.setMinimumSize(new java.awt.Dimension(250, 250));
		panel_orglsb.setPreferredSize(new java.awt.Dimension(250, 250));
		getContentPane().add(panel_orglsb);
		panel_orglsb.setBounds(80, 380, 250, 250);
		panel_orglsb.setLayout(new BorderLayout());

		panel_diff.setMinimumSize(new java.awt.Dimension(250, 250));
		panel_diff.setPreferredSize(new java.awt.Dimension(250, 250));
		getContentPane().add(panel_diff);
		panel_diff.setBounds(370, 80, 250, 250);
		panel_diff.setLayout(new BorderLayout());

		jLabel1.setText(tasks.Main.messages
				.getString("guiVisualAttack_coverImage"));
		jLabel1.setHorizontalAlignment(JLabel.CENTER);
		getContentPane().add(jLabel1);
		jLabel1.setBounds(80, 50, 250, 14);

		lbl_steganogramm.setText(tasks.Main.messages
				.getString("guiVisualAttack_stegoImage"));
		lbl_steganogramm.setHorizontalAlignment(JLabel.CENTER);
		getContentPane().add(lbl_steganogramm);
		lbl_steganogramm.setBounds(660, 50, 250, 14);

		lbl_diff.setText(tasks.Main.messages
				.getString("guiVisualAttack_diffImage"));
		lbl_diff.setHorizontalAlignment(JLabel.CENTER);
		getContentPane().add(lbl_diff);
		lbl_diff.setBounds(370, 50, 250, 14);

		lbl_orglsb.setText(tasks.Main.messages
				.getString("guiVisualAttack_LSBOfCoverImage"));
		lbl_orglsb.setHorizontalAlignment(JLabel.CENTER);
		getContentPane().add(lbl_orglsb);
		lbl_orglsb.setBounds(80, 360, 250, 14);

		lbl_steglsb.setText(tasks.Main.messages
				.getString("guiVisualAttack_LSBOfstegoImage"));
		lbl_steglsb.setHorizontalAlignment(JLabel.CENTER);
		getContentPane().add(lbl_steglsb);
		lbl_steglsb.setBounds(660, 360, 250, 14);

		jPanel1.setLayout(null);

		this.btn_orglsb.setText(tasks.Main.messages
				.getString("guiVisualAttack_LSBOfCover"));
		jPanel1.add(btn_orglsb);
		btn_orglsb.setBounds(30, 60, 200, 23);
		btn_orglsb.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btn_orglsbActionPerformed(evt);
			}
		});

		this.btn_steglsb.setText(tasks.Main.messages
				.getString("guiVisualAttack_LSBOfStego"));
		jPanel1.add(btn_steglsb);
		btn_steglsb.setBounds(30, 90, 200, 23);
		btn_steglsb.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btn_steglsbActionPerformed(evt);
			}
		});

		btn_diff.setText(tasks.Main.messages
				.getString("guiVisualAttack_diffImage"));
		jPanel1.add(btn_diff);
		btn_diff.setBounds(30, 30, 200, 23);
		btn_diff.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btn_diffActionPerformed(evt);
			}
		});

		getContentPane().add(jPanel1);
		jPanel1.setBounds(370, 380, 260, 250);

		pack();
	}

	// </editor-fold>

	private void btn_diffActionPerformed(java.awt.event.ActionEvent evt) {

		try {
			tasks.HelperFunctions.Image img;
			img = VisualAttack.diffImg(HelperFunctions.read(org),
					HelperFunctions.read(steg));
			HelperFunctions.write(stegFileName + "_diff.pgm", img);
			GuiPgmLabel pgm = new GuiPgmLabel(new File(stegFileName + "_diff.pgm"));

			panel_diff.add(pgm, BorderLayout.CENTER);
			panel_diff.repaint();
			pgm.repaint();

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	private void btn_orglsbActionPerformed(java.awt.event.ActionEvent evt) {
		try {
			tasks.HelperFunctions.Image img;
			img = VisualAttack.showLSB(HelperFunctions.read(org));
			HelperFunctions.write(fileName + "_LSB.pgm", img);
			GuiPgmLabel pgm = new GuiPgmLabel(new File(fileName + "_LSB.pgm"));

			panel_orglsb.add(pgm, BorderLayout.CENTER);
			panel_orglsb.repaint();
			pgm.repaint();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private void btn_steglsbActionPerformed(java.awt.event.ActionEvent evt) {
		try {
			tasks.HelperFunctions.Image img;
			img = VisualAttack.showLSB(HelperFunctions.read(steg));
			HelperFunctions.write(stegFileName + "_LSB.pgm", img);
			GuiPgmLabel pgm = new GuiPgmLabel(new File(stegFileName
					+ "_LSB.pgm"));

			panelemblsb.add(pgm, BorderLayout.CENTER);
			panelemblsb.repaint();
			pgm.repaint();

		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	// Variables declaration - do not modify
	private javax.swing.JButton btn_diff;
	private javax.swing.JButton btn_orglsb;
	private javax.swing.JButton btn_steglsb;

	private javax.swing.JLabel jLabel1;
	private javax.swing.JPanel jPanel1;
	private javax.swing.JLabel lbl_diff;
	private javax.swing.JLabel lbl_orglsb;
	private javax.swing.JLabel lbl_steganogramm;
	private javax.swing.JLabel lbl_steglsb;
	private javax.swing.JPanel panel_diff;
	private javax.swing.JPanel panel_emb;
	private javax.swing.JPanel panel_org;
	private javax.swing.JPanel panel_orglsb;
	private javax.swing.JPanel panelemblsb;

	// End of variables declaration

}
