package tasks;

import java.util.Locale;
import java.util.ResourceBundle;

import gui.GuiMainWindow;

public class Main {

    /* Fuer Internationalisierung */
    public static ResourceBundle messages;  
	
    /**
     * Startet die Oberfläche
     * @param args optional: die Sprache (unterstützt "de" und "en")
     */
    
    public static void main(String args[]) {
    	
    	
    	/** Der folgende Teil ist nötig für die Internationalisierung */
    	String language;
    	if (args.length != 1) {
    	    language = new String("de");
    	} else {
    	    language = new String(args[0]);
    	}
    	Locale currentLocale;
    	currentLocale = new Locale(language, "");
    	messages = ResourceBundle.getBundle("localmessages",currentLocale);
    	
    	// start the GUI
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GuiMainWindow().setVisible(true);
            }
        });
    }

}
